Index: /java/main/src/test/java/com/framsticks/gui/ProcedureBrowserTest.java
===================================================================
--- /java/main/src/test/java/com/framsticks/gui/ProcedureBrowserTest.java	(revision 95)
+++ /java/main/src/test/java/com/framsticks/gui/ProcedureBrowserTest.java	(revision 96)
@@ -16,4 +16,5 @@
 import com.framsticks.test.TestClass;
 import com.framsticks.util.dispatching.RunAt;
+import static com.framsticks.core.InstanceUtils.*;
 
 @Test
@@ -34,5 +35,5 @@
 	@Test(timeOut = 10000)
 	public void testShow() {
-		assertDispatch(instance, new RunAt<Instance>() {
+		instance.dispatch(new RunAt<Instance>() {
 			@Override
 			public void run() {
@@ -43,8 +44,8 @@
 		clickAndExpandPath("test");
 
-		assertDispatch(instance, new RunAt<Instance>() {
+		instance.dispatch(new RunAt<Instance>() {
 			@Override
 			public void run() {
-				assertThat(instance.bindAccess("/").getFramsClass().getParam("history")).isInstanceOf(StringParam.class);
+				assertThat(bindAccess(instance, "/").getFramsClass().getParam("history")).isInstanceOf(StringParam.class);
 			}
 		});
@@ -52,8 +53,8 @@
 		// monitor.useFor(4.0);
 
-		assertDispatch(instance, new RunAt<Instance>() {
+		instance.dispatch(new RunAt<Instance>() {
 			@Override
 			public void run() {
-				AccessInterface access = instance.bindAccess("/");
+				AccessInterface access = bindAccess(instance, "/");
 				assertThat(access).isInstanceOf(ReflectionAccess.class);
 				FramsClass framsClass = access.getFramsClass();
@@ -74,8 +75,8 @@
 		waitForIdle();
 
-		assertDispatch(instance, new RunAt<Instance>() {
+		instance.dispatch(new RunAt<Instance>() {
 			@Override
 			public void run() {
-				assertThat(instance.bindAccess("/").get("history", String.class)).isEqualTo("argument|");
+				assertThat(bindAccess(instance, "/").get("history", String.class)).isEqualTo("argument|");
 			}
 		});
@@ -84,8 +85,8 @@
 		waitForIdle();
 
-		assertDispatch(instance, new RunAt<Instance>() {
+		instance.dispatch(new RunAt<Instance>() {
 			@Override
 			public void run() {
-				assertThat(instance.bindAccess("/").get("history", String.class)).isEqualTo("");
+				assertThat(bindAccess(instance, "/").get("history", String.class)).isEqualTo("");
 			}
 		});
Index: /java/main/src/test/java/com/framsticks/hosting/ServerTest.java
===================================================================
--- /java/main/src/test/java/com/framsticks/hosting/ServerTest.java	(revision 96)
+++ /java/main/src/test/java/com/framsticks/hosting/ServerTest.java	(revision 96)
@@ -0,0 +1,156 @@
+package com.framsticks.hosting;
+
+// import org.apache.log4j.Logger;
+import org.testng.annotations.Test;
+
+import com.framsticks.core.ObjectInstance;
+import com.framsticks.core.Path;
+import com.framsticks.core.XmlBasedTest;
+import com.framsticks.remote.RemoteInstance;
+
+import com.framsticks.test.TestClass;
+import com.framsticks.core.Instance;
+import com.framsticks.params.FramsClass;
+import com.framsticks.util.AbstractStateFunctor;
+import com.framsticks.util.dispatching.Dispatching;
+import com.framsticks.params.AccessInterface;
+import com.framsticks.params.PropertiesAccess;
+import com.framsticks.params.ValueParam;
+import com.framsticks.params.types.ProcedureParam;
+import com.framsticks.util.dispatching.Dispatching.Waiter;
+import com.framsticks.util.dispatching.Future;
+import com.framsticks.util.dispatching.RunAt;
+
+import static com.framsticks.core.InstanceUtils.*;
+
+import static org.fest.assertions.Assertions.*;
+
+@Test
+public class ServerTest extends XmlBasedTest {
+
+	protected RemoteInstance remote;
+	protected FramsClass remoteTestFramsClass;
+	protected Path remotePath;
+
+	protected Server server;
+	protected ObjectInstance hosted;
+	protected TestClass hostedObject;
+
+	@Override
+	protected String getConfigurationName() {
+		return "ServerTest.xml";
+	}
+
+	@Test
+	public void runServer() {
+		assertThat(framsticks.size()).isEqualTo(2);
+		assertThat(framsticks.get("test")).isInstanceOf(Server.class);
+		assertThat(framsticks.get("remote")).isInstanceOf(RemoteInstance.class);
+
+		server = (Server) framsticks.get("test");
+		remote = (RemoteInstance) framsticks.get("remote");
+		assertThat(server.getHosted()).isInstanceOf(ObjectInstance.class);
+		hosted = (ObjectInstance) server.getHosted();
+		assertThat(hosted.getRootObject()).isInstanceOf(TestClass.class);
+		hostedObject = hosted.getRootObject(TestClass.class);
+	}
+
+	@Test(dependsOnMethods = "runServer")
+	public void fetchInfo() {
+		remote.dispatch(new RunAt<Instance>() {
+			@Override
+			public void run() {
+				remote.fetchInfo(Path.to(remote, "/"), new Future<FramsClass>(failOnException()) {
+					@Override
+					protected void result(FramsClass result) {
+						remoteTestFramsClass = result;
+						assertThat(result.getId()).isEqualTo("TestClass");
+					}
+				});
+			}
+		});
+
+		Dispatching.synchronize(remote, 1.0);
+	}
+
+	@Test(dependsOnMethods = "fetchInfo")
+	public void resolveAndfetchRootObject() {
+		final Waiter waiter = produceWaiter(1.0);
+
+		remote.dispatch(new RunAt<Instance>() {
+			@Override
+			public void run() {
+				final Path path = Path.to(remote, "/");
+				assertThat(path.isResolved()).isFalse();
+
+				remote.resolve(path, new Future<Path>(failOnException()) {
+					@Override
+					protected void result(final Path result) {
+						assertThat(result.isResolved()).isTrue();
+						remotePath = result;
+						remote.fetchValues(result, new AbstractStateFunctor(failOnException()) {
+							@Override
+							public void call() {
+								AccessInterface access = bindAccess(result);
+								assertThat(access).isInstanceOf(PropertiesAccess.class);
+								assertThat(access.get("name", String.class)).isEqualTo("a test name");
+								waiter.pass();
+							}
+						});
+					}
+				});
+			}
+		});
+	}
+
+	@Test(dependsOnMethods = "resolveAndfetchRootObject")
+	public void setValueName() {
+		final Waiter waiter = produceWaiter(2.0);
+
+		storeValue(remotePath, remoteTestFramsClass.getParamEntry("name", ValueParam.class), "new name", new AbstractStateFunctor(failOnException()) {
+			@Override
+			public void call() {
+				/** And now check directly whether it was really set. */
+				hosted.dispatch(new RunAt<Instance>() {
+					@Override
+					public void run() {
+						assertThat(hostedObject.getName()).isEqualTo("new name");
+						waiter.pass();
+					}
+				});
+			}
+		});
+	}
+
+	@Test(dependsOnMethods = "setValueName")
+	public void callMethod() {
+		final Waiter firstWaiter = produceWaiter(2.0);
+		final Waiter waiter = produceWaiter(2.0);
+
+		call(remotePath, remoteTestFramsClass.getParamEntry("resetHistory", ProcedureParam.class), new Object[] {}, new Future<Object>(failOnException()) {
+			@Override
+			protected void result(Object result) {
+				firstWaiter.pass();
+			}
+		});
+
+		call(remotePath, remoteTestFramsClass.getParamEntry("appendHistory", ProcedureParam.class), new Object[] {"next word"}, new Future<Object>(failOnException()) {
+			@Override
+			protected void result(Object result) {
+				hosted.dispatch(new RunAt<Instance>() {
+					@Override
+					public void run() {
+						assertThat(hostedObject.getHistory()).isEqualTo("next word|");
+						waiter.pass();
+					}
+				});
+			}
+		});
+
+	}
+
+	@Test(dependsOnMethods = "callMethod")
+	public void endWait() {
+		monitor.useFor(1.0);
+	}
+}
Index: /java/main/src/test/java/com/framsticks/params/FramsClassBuilderTest.java
===================================================================
--- /java/main/src/test/java/com/framsticks/params/FramsClassBuilderTest.java	(revision 95)
+++ /java/main/src/test/java/com/framsticks/params/FramsClassBuilderTest.java	(revision 96)
@@ -1,4 +1,5 @@
 package com.framsticks.params;
 
+import java.util.Arrays;
 
 import org.testng.annotations.BeforeClass;
@@ -7,4 +8,5 @@
 import com.framsticks.params.types.ProcedureParam;
 import com.framsticks.params.types.StringParam;
+import com.framsticks.parsers.Savers;
 import com.framsticks.test.TestClass;
 import com.framsticks.test.TestConfiguration;
@@ -17,5 +19,4 @@
 	ReflectionAccess access;
 	TestClass test;
-
 
 	@BeforeClass
@@ -36,4 +37,5 @@
 		assertThat(framsClass.getParam("appendHistory")).isInstanceOf(ProcedureParam.class);
 		assertThat(framsClass.getParam("resetHistory")).isInstanceOf(ProcedureParam.class);
+
 		ProcedureParam appendHistory = framsClass.getParamEntry("appendHistory", ProcedureParam.class);
 		assertThat(appendHistory.getArgumentsType().size()).isEqualTo(1);
@@ -42,4 +44,37 @@
 
 	@Test(dependsOnMethods = "checkProcedureParams")
+	public void print() {
+		assertThat(Savers.saveFramsClass(new ListSink(), framsClass).getOut()).isEqualTo(
+				Arrays.asList(
+					"class:",
+					"name:TestClass",
+					"id:TestClass",
+					"",
+					"prop:",
+					"id:name",
+					"name:Name",
+					"type:s",
+					"",
+					"prop:",
+					"id:history",
+					"name:History",
+					"type:s",
+					"",
+					"prop:",
+					"id:appendHistory",
+					"name:AppendHistory",
+					"type:p d(s arg0)",
+					"",
+					"prop:",
+					"id:resetHistory",
+					"name:ResetHistory",
+					"type:p()",
+					""
+				)
+			);
+	}
+
+
+	@Test(dependsOnMethods = "print")
 	public void callProcedures() {
 		access = new ReflectionAccess(TestClass.class, framsClass);
Index: /java/main/src/test/java/com/framsticks/params/ParamBuilderTest.java
===================================================================
--- /java/main/src/test/java/com/framsticks/params/ParamBuilderTest.java	(revision 95)
+++ /java/main/src/test/java/com/framsticks/params/ParamBuilderTest.java	(revision 96)
@@ -23,4 +23,5 @@
 		assertThat(builderFramsClass.getName()).isEqualTo("prop");
 		assertThat(builderFramsClass.getId()).isEqualTo("prop");
+		assertThat(builderFramsClass.getParamEntry("flags", ValueParam.class).getDef(Object.class)).isEqualTo(new Integer(0));
 		assertThat(builderFramsClass.getParamEntry("id", Param.class)).isInstanceOf(StringParam.class);
 	}
Index: /java/main/src/test/java/com/framsticks/running/FramsServerTest.java
===================================================================
--- /java/main/src/test/java/com/framsticks/running/FramsServerTest.java	(revision 95)
+++ /java/main/src/test/java/com/framsticks/running/FramsServerTest.java	(revision 96)
@@ -3,36 +3,24 @@
 import org.testng.annotations.Test;
 
-import com.framsticks.core.Framsticks;
-import com.framsticks.test.TestConfiguration;
-import com.framsticks.util.dispatching.Monitor;
+import com.framsticks.core.XmlBasedTest;
 
 import static org.fest.assertions.Assertions.*;
 
 @Test
-public class FramsServerTest extends TestConfiguration {
+public class FramsServerTest extends XmlBasedTest {
+
+	@Override
+	protected String getConfigurationName() {
+		return "FramsServerTest.xml";
+	}
 
 	@Test(timeOut = 3000)
 	public void runServer() {
-		Framsticks framsticks = Framsticks.loadConfiguration(FramsServerTest.class.getResourceAsStream("/configs/FramsServerTest.xml"));
+		assertThat(framsticks.size()).isEqualTo(1);
+		assertThat(framsticks.get("frams")).isInstanceOf(FramsServer.class);
 
-		assertThat(framsticks.getObservables().size()).isEqualTo(1);
-		assertThat(framsticks.getObservables().get("frams")).isInstanceOf(FramsServer.class);
-		// assertThat(framsticks.getObservables().get("remote")).isInstanceOf(RemoteInstance.class);
-
-		new Monitor(framsticks).use().useFor(1.0).drop().join();
-
-		// monitor.use();
-
-		// Dispatching.sleep(1000);
-
-		// // monitor.waitFor();
-		// monitor.drop();
-		// monitor.join();
-
-		// framsticks.start();
-
-		// framsticks.waitForObservables();
-
+		monitor.useFor(1.0);
 	}
 
+
 }
Index: /java/main/src/test/java/com/framsticks/test/MonitorBasedTest.java
===================================================================
--- /java/main/src/test/java/com/framsticks/test/MonitorBasedTest.java	(revision 96)
+++ /java/main/src/test/java/com/framsticks/test/MonitorBasedTest.java	(revision 96)
@@ -0,0 +1,36 @@
+package com.framsticks.test;
+
+import org.testng.annotations.AfterClass;
+import org.testng.annotations.BeforeClass;
+import org.testng.annotations.Test;
+
+import com.framsticks.util.dispatching.Joinable;
+import com.framsticks.util.dispatching.Monitor;
+
+@Test
+public abstract class MonitorBasedTest extends TestConfiguration {
+
+	protected Monitor monitor;
+	protected Joinable subject;
+
+	protected abstract Joinable createSubject();
+
+	@BeforeClass(timeOut = 2000)
+	public void setUp() {
+		subject = createSubject();
+
+		monitor = new Monitor(subject);
+		monitor.setTaskExceptionHandler(createExceptionHandler());
+		monitor.use();
+
+		setUpAfterUse();
+	}
+
+	protected void setUpAfterUse() {
+	}
+
+	@AfterClass(timeOut = 3000)
+	public void tearDown() {
+		monitor.drop().join();
+	}
+}
Index: /java/main/src/test/java/com/framsticks/test/TestConfiguration.java
===================================================================
--- /java/main/src/test/java/com/framsticks/test/TestConfiguration.java	(revision 95)
+++ /java/main/src/test/java/com/framsticks/test/TestConfiguration.java	(revision 96)
@@ -1,6 +1,8 @@
 package com.framsticks.test;
 
+import java.util.HashSet;
 import java.util.LinkedList;
 import java.util.List;
+import java.util.Set;
 
 import org.apache.log4j.Logger;
@@ -8,6 +10,12 @@
 import org.testng.annotations.*;
 
+import com.framsticks.util.FramsticksException;
 import com.framsticks.util.dispatching.Dispatcher;
-import com.framsticks.util.dispatching.RunAt;
+import com.framsticks.util.dispatching.Dispatching;
+import com.framsticks.util.dispatching.Dispatching.Waiter;
+import com.framsticks.util.dispatching.ExceptionHandler;
+import com.framsticks.util.dispatching.ExceptionResultHandler;
+
+import static org.fest.assertions.Assertions.*;
 
 public class TestConfiguration {
@@ -21,70 +29,71 @@
 	}
 
-	private final List<AsyncAssert<?>> asyncAssertions = new LinkedList<AsyncAssert<?>>();
+	private final List<AssertionError> asyncAssertions = new LinkedList<>();
 
-	public class AsyncAssert<C> extends RunAt<C> {
-		final RunAt<? extends C> runnable;
-		boolean done = false;
-		AssertionError assertion;
+	public ExceptionHandler createExceptionHandler() {
+		return new ExceptionHandler() {
+			@Override
+			public boolean handle(Dispatcher<?> dispatcher, Throwable throwable) {
+				AssertionError ae;
+				if (AssertionError.class.isInstance(throwable)) {
+					ae = AssertionError.class.cast(throwable);
+				} else {
+					ae = new AssertionError();
+					ae.initCause(throwable);
+				}
+				synchronized (asyncAssertions) {
+					asyncAssertions.add(ae);
+				}
+				return true;
+			}
+		};
+	}
 
-		/**
-		 * @param runnable
-		 */
-		public AsyncAssert(RunAt<? extends C> runnable) {
-			this.runnable = runnable;
-		}
-
-		@Override
-		public void run() {
+	@AfterMethod
+	public void waitForWaiters() {
+		for (Waiter w : waiters) {
 			try {
-				runnable.run();
-			} catch (AssertionError e) {
-				assertion = e;
-			}
-			synchronized (this) {
-				done = true;
-				this.notifyAll();
+				w.waitFor();
+			} catch (FramsticksException e) {
+				AssertionError ae = new AssertionError();
+				ae.initCause(e);
+				asyncAssertions.add(ae);
 			}
 		}
 	}
 
-	public <C> void assertDispatch(Dispatcher<C> dispatcher, RunAt<? extends C> runnable) {
-		AsyncAssert<C> assertion = new AsyncAssert<C>(runnable);
+	@AfterMethod(timeOut = 1000, dependsOnMethods = "waitForWaiters")
+	public void processAsyncAssertions() {
 		synchronized (asyncAssertions) {
-			asyncAssertions.add(assertion);
-		}
-		dispatcher.dispatch(assertion);
-	}
-
-	@BeforeMethod
-	public void clearAsyncAsserts() {
-		synchronized (asyncAssertions) {
-			asyncAssertions.clear();
+			if (asyncAssertions.isEmpty()) {
+				return;
+			}
+			AssertionError a = asyncAssertions.get(0);
+			asyncAssertions.remove(0);
+			throw a;
 		}
 	}
 
-	@AfterMethod(timeOut = 5000)
-	public void waitForAsyncAsserts() {
-		while (true) {
-			AsyncAssert<?> assertion;
-			synchronized (asyncAssertions) {
-				if (asyncAssertions.isEmpty()) {
-					return;
-				}
-				assertion = asyncAssertions.get(0);
-				asyncAssertions.remove(0);
+	final Set<Waiter> waiters = new HashSet<>();
+
+	@BeforeMethod
+	public void clearWaiters() {
+		waiters.clear();
+	}
+
+	protected Dispatching.Waiter produceWaiter(double timeOut) {
+		Waiter waiter = new Waiter(timeOut);
+		waiters.add(waiter);
+		return waiter;
+	}
+
+	public static ExceptionResultHandler failOnException() {
+		return new ExceptionResultHandler() {
+			@Override
+			public void handle(FramsticksException e) {
+				assertThat(e).isNull();
 			}
-			synchronized (assertion) {
-				while (!assertion.done) {
-					try {
-						assertion.wait();
-					} catch (InterruptedException ignored) {
-					}
-				}
-				if (assertion.assertion != null) {
-					throw assertion.assertion;
-				}
-			}
-		}
+		};
+
 	}
 }
